package coolWatch;

import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;
import com.nttdocomo.io.*;
import com.nttdocomo.util.*;

import java.io.*;
import java.util.*;

import javax.microedition.io.*;

class numberDemoCanvas extends Canvas{
    int nowNumber;
    byte numberFlag[]=new byte[7];
    int maxStep=8;
    int nowStep[]=new int[7];

    int dateNum[]=new int[8];
    int nowDate=0;
    public numberDemoCanvas(){
    setDate();
    doNumber(dateNum[0]);
    
    setSoftLabel(Frame.SOFT_KEY_1,"Q");
    }


    public void paint(Graphics g){
        g.setColor(g.getColorOfName(Graphics.BLACK));
        g.fillRect(0,0,getWidth(),getHeight());
        
        g.setColor(g.getColorOfName(Graphics.WHITE));
        drawNumber(g,20,10,getWidth()-40,getHeight()-20,10,10);

        drawColone(g);
    }

    public void drawColone(Graphics g){
        if(nowNumber==-1){
            int w=10;
            int y=(getHeight()-w)/3;
            int x=(getWidth()-w)/2;
            g.drawRect(x,y,w,w);
            g.drawRect(x,y+y+w,w,w);
        }

    }
    public void drawNumber(Graphics g,int x,int y,int width,int height,int hSize,int vSize){

        int w=width;//-hSize;
        int h=(height-vSize*3)/2;

        int sW=w/maxStep;
        int sH=h/maxStep;

        //drawTop
        if(nowStep[0]>=maxStep-1){
            g.drawRect(x,y,w,vSize);
        }
        else if(nowStep[0]>0){
            int dW=sW*nowStep[0];
            g.drawRect(x+(w-dW)/2,y,dW,vSize);
        }


        /*
        if(nowStep[1]>=maxStep-1){

        }
        else if(nowStep[1]>0){

        }
         */
        //draw top_side

        if(nowStep[1]>=maxStep-1){
            g.drawRect(x,y+vSize,hSize,h);
        }
        else if(nowStep[1]>0){
            int dH=sH*nowStep[1];
            g.drawRect(x,y+vSize+(h-dH)/2,hSize,dH);
        }


        if(nowStep[2]>=maxStep-1){
            g.drawRect(x+width-hSize,y+vSize,vSize,h);
        }
        else if(nowStep[2]>0){
            int dH=sH*nowStep[2];
            g.drawRect(x+width-hSize,y+vSize+(h-dH)/2,vSize,dH);
        }




        //middle
        if(nowStep[3]>=maxStep-1){
            g.drawRect(x,y+(vSize+h),w,vSize);
        }
        else if(nowStep[3]>0){
            int dW=sW*nowStep[3];
            // g.drawRect(x+(w-dW)/2,y,dW,vSize);
            g.drawRect(x+(w-dW)/2,y+(vSize+h),dW,vSize);
        }


        //draw bottom_side
        if(nowStep[4]>=maxStep-1){
            g.drawRect(x,y+vSize+(vSize+h),hSize,h);
        }
        else if(nowStep[4]>0){
            int dH=sH*nowStep[4];
            g.drawRect(x,y+vSize+(vSize+h)+(h-dH)/2,hSize,dH);

        }

        if(nowStep[5]>=maxStep-1){
            g.drawRect(x+width-hSize,y+vSize+(vSize+h),vSize,h);
        }
        else if(nowStep[5]>0){
            int dH=sH*nowStep[5];
            g.drawRect(x+width-hSize,y+vSize+(vSize+h)+(h-dH)/2,vSize,dH);
        }



        //bottom

        if(nowStep[6]>=maxStep-1){
            g.drawRect(x,y+(vSize+h)*2,w,vSize);
        }
        else if(nowStep[6]>0){
            int dW=sW*nowStep[6];
            g.drawRect(x+(w-dW)/2,y+(vSize+h)*2,dW,vSize);
        }

    }



    public void setNumberBar(int location){
        numberFlag[location]=1;
    }


    public void setNumber(int number){
        nowNumber=number;
        
        if(number<0 ||number>9)return;
        
        if(number != 1 && number!= 4)
        setNumberBar(0);

        //draw top_side

        //045689
        if(number==0 ||  number==4 || number==5 || number==6 || number ==8 || number==9)
        setNumberBar(1);
        //012345789
        if(number!=6 && number !=5)
        setNumberBar(2);

        //draw middle
        //2345689
        if(number!= 0 && number!=1 && number!=7)
        setNumberBar(3);

        //draw bottom_side
        //0268
        if(number==0 ||  number==2 || number==6 || number ==8)
        setNumberBar(4);
        //013456789
        if(number!= 2)
        setNumberBar(5);

        //draw bottom
        //023568
        if(number==0 ||  number==2 || number==3 || number==5 || number ==6 || number==8)
        setNumberBar(6);
    }

    public void changeCount(){

        for(int i=0;i<7;i++){
            if(numberFlag[i]==1){
                nowStep[i]++;
                if(nowStep[i]>maxStep-1)
                nowStep[i]=maxStep-1;
            }
            else{
                nowStep[i]--;
                if(nowStep[i]<0)
                nowStep[i]=0;
            }
        }

    }


    public void doTimer(int id){
        if(id==1){
            changeCount();
            repaint();
        }else{
            nextStep();
        }
    }

    public void nextStep(){
        nowDate++;
        if(nowDate>=dateNum.length){
            setDate();
            nowDate=0;
        }
        doNumber(dateNum[nowDate]);
        //setSoftLabel(Frame.SOFT_KEY_1,""+dateNum[nowDate]);
    }

    public void setDate(){
        Calendar now=Calendar.getInstance();
        int hour=now.get(Calendar.HOUR);
        if(now.get(Calendar.AM_PM)==Calendar.PM)hour+=12;
        int min=now.get(Calendar.MINUTE);
        dateNum[0]=hour/10;
        dateNum[1]=hour%10;
        dateNum[2]=-2;
        dateNum[3]=-1;
        dateNum[4]=-2;
        dateNum[5]=min/10;
        dateNum[6]=min%10;
        dateNum[7]=-2;
    }


    public void doUp(){

    }

    public void doDown(){

    }

    public void doLeft(){

    }

    public void doRight(){

    }

    public void doSelect(){

    }

    public void doSoft1(){
        IApplication.getCurrentApp().terminate();
    }
    public void doSoft2(){
        //CoolWatch.mode=(CoolWatch.mode+1)%3;
       // setSoftLabel(Frame.SOFT_KEY_2,""+CoolWatch.mode);
    }

    public void doNumber(int param){
        for(int i=0;i<7;i++)
        numberFlag[i]=0;

        setNumber(param);
    }

    public void processEvent(int type,int param){
        if(type==Display.KEY_PRESSED_EVENT){
            if(param==Display.KEY_UP){
                doUp();
            }
            else if(param==Display.KEY_DOWN){
                doDown();
            }
            else if(param==16){//Display.KEY_LEFT
                doLeft();
            }
            else if(param==Display.KEY_RIGHT){
                doRight();
            }
            else if(param==20){//Display.KEY_SELECT
                doSelect();
            }else if(param==Display.KEY_SOFT1){
                doSoft1();
            }else if(param==Display.KEY_SOFT2){
                doSoft2();
            }else{
                doNumber(param);
            }

        }else if(type==Display.TIMER_EXPIRED_EVENT){
            doTimer(param);
        }

    }
}


